<?php

namespace Drupal\synhelper\Service;

use Drupal\Core\Config\FileStorage;

/**
 * ParagraphImport class.
 *
 * @internal
 *   For internal usage by the Commerce synhelper module.
 */
class BlockImport implements ContentImportInterface {

  /**
   * Service for service.
   *
   * @var Drupal\synhelper\Service\FilesImport
   */
  protected $filesImport;

  /**
   * Service for service.
   *
   * @var Drupal\synhelper\Service\TaxonomyImport
   */

  protected $taxonomyImport;
  /**
   * Service for service.
   *
   * @var Drupal\synhelper\Service\ParagraphImport
   */
  protected $paragraphImport;

  /**
   * Controller constructor.
   */
  public function __construct(
    ContentImportInterface $filesImport,
    ContentImportInterface $paragraphImport,
    ContentImportInterface $taxonomyImport
  ) {
    $this->filesImport = $filesImport;
    $this->paragraphImport = $paragraphImport;
    $this->taxonomyImport = $taxonomyImport;
  }

  /**
   * Import Blocks.
   */
  public function import(string $directory) {
    $sourceBlock = new FileStorage($directory . '/block');
    foreach ($sourceBlock->listAll() as $file) {
      $data = $sourceBlock->read($file);
      $storage = \Drupal::entityTypeManager()->getStorage('block_content');
      foreach ($data as $key => $value) {
        switch ($key) {
          case 'field_image':
          case 'field_gallery':
            $b[$key] = $this->filesImport->importImages($value);
            break;

          case 'field_attach':
            $b[$key] = $this->filesImport->importAttach($value);
            break;

          case 'field_paragraph':
            $b[$key] = $this->paragraphImport->importParagraph($value);
            break;

          default:
            $b[$key] = $value;
            break;
        }
      }
      $b['uid'] = 1;
      $block = $storage->create($b);
      $block->save();
    }
  }

}
